Package net.sf.saxon.style

## Class XSLAttributeSet

- java.lang.Object
- - net.sf.saxon.tree.linked.NodeImpl
  - - net.sf.saxon.tree.linked.ParentNodeImpl
    - - net.sf.saxon.tree.linked.ElementImpl
      - - net.sf.saxon.style.StyleElement
        - - net.sf.saxon.style.XSLAttributeSet

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `MutableNodeInfo`, `NamespaceResolver`, `NodeInfo`, `Sequence`, `Location`, `StylesheetComponent`, `SteppingNode<NodeImpl>`, `SiblingCountingNode`, `org.xml.sax.Locator`

      public class XSLAttributeSet
      extends StyleElement
      implements StylesheetComponent

  An xsl:attribute-set element in the stylesheet.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.saxon.style.StyleElement

      `StyleElement.OnFailure`

  - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.style.StyleElement

      `ACTION_COMPILE, ACTION_FIXUP, ACTION_OPTIMIZE, ACTION_PROCESS_ATTRIBUTES, ACTION_TYPECHECK, ACTION_VALIDATE, actionsCompleted, defaultCollationName, defaultMode, defaultXPathNamespace, expandText, extensionNamespaces, reportingCircumstances, staticContext, validationError, version`

    - ### Fields inherited from class net.sf.saxon.tree.linked.NodeImpl

      `NODE_LETTER`

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XSLAttributeSet()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkCircularity​(XSLAttributeSet origin)` | Check for circularity: specifically, check that this attribute set does not contain a direct or indirect reference to the one supplied as a parameter
    `void` | `checkCompatibility​(Component component)` | Check the compatibility of this component with another component that it is overriding
    `void` | `compileDeclaration​(Compilation compilation, ComponentDeclaration decl)` | Compile the attribute set
    `void` | `generateByteCode​(Optimizer opt)` | Generate byte code if appropriate
    `AttributeSet` | `getActor()` | Get the corresponding Procedure object that results from the compilation of this StylesheetProcedure
    `StructuredQName` | `getAttributeSetName()` | Get the name of this attribute set
    `java.util.List<Expression>` | `getContainedInstructions()` | Get the contained xsl:attribute instructions, in compiled form
    `StructuredQName` | `getObjectName()` | Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc.
    `SlotManager` | `getSlotManager()` | Get details of stack frame
    `SymbolicName` | `getSymbolicName()` | Get the symbolic name of the component, that is, the combination of the component kind and the qualified name
    `StructuredQName[]` | `getUseAttributeSetNames()` |
    `void` | `index​(ComponentDeclaration decl, PrincipalStylesheetModule top)` | Method supplied by declaration elements to add themselves to a stylesheet-level index
    `boolean` | `isDeclaration()` | Ask whether this node is a declaration, that is, a permitted child of xsl:stylesheet (including xsl:include and xsl:import).
    `boolean` | `isDeclaredStreamable()` | Ask whether the attribute set is declared streamable
    `void` | `optimize​(ComponentDeclaration declaration)` | Optimize the stylesheet construct
    `void` | `prepareAttributes()` | Set the attribute list for the element.
    `void` | `validate​(ComponentDeclaration decl)` | Check that the stylesheet element is valid.

    - ### Methods inherited from class net.sf.saxon.style.StyleElement

      `allocateLocation, bindLocalVariable, bindVariable, checkEmpty, checkTopLevel, checkUnknownAttribute, compile, compileError, compileError, compileError, compileError, compileError, compileError, compileErrorInAttribute, compileSequenceConstructor, compileSequenceConstructor, compileWarning, compileWarning, compileWarning, fixupReferences, generateId, getAttributeValue, getBaseURI, getBindingInformation, getCompilation, getConfiguration, getContainingPackage, getContainingSlotManager, getDeclaredVisibility, getDefaultCollationName, getDefaultXPathNamespace, getNamespaceResolver, getPackageData, getPrincipalStylesheetModule, getProperties, getSchemaType, getStaticContext, getStaticContext, getTypeAnnotation, getUsedPackage, getVisibility, getWithParamInstructions, getXslOriginal, hasImplicitBinding, invalidAttribute, isExtensionAttributeAllowed, isExtensionNamespace, isInstruction, isPermittedChild, isSchemaAware, issueWarning, issueWarning, isTopLevel, isWithinDeclaredStreamableConstruct, makeAttributeValueTemplate, makeExpression, makeExpressionVisitor, makeQName, makeRetainedStaticContext, makeSequenceType, markTailCalls, mayContainFallback, mayContainParam, mayContainSequenceConstructor, postValidate, processAllAttributes, processBooleanAttribute, processStandardAttributes, processVersionAttribute, reportAbsence, requireSyntaxExtensions, seesAvuncularVariables, setCompilation, setObjectName, setValidationError, substituteFor, typeCheck, typeCheck, validateChildren, validateSubtree, validateValidationAttribute`

    - ### Methods inherited from class net.sf.saxon.tree.linked.ElementImpl

      `addAttribute, addNamespace, addNamespace, attributes, checkNotNamespaceSensitiveElement, copy, delete, fixupInsertedNamespaces, generateId, getAllNamespaces, getAttributeValue, getColumnNumber, getDeclaredNamespaces, getLineNumber, getNodeKind, getNodeName, getRoot, getSchemaType, getSystemId, getURIForPrefix, initialise, isId, isIdref, isInScopeNamespace, isNilled, iteratePrefixes, removeAttribute, removeNamespace, removeTypeAnnotation, rename, replaceStringValue, setAttributeInfo, setAttributes, setLocation, setNamespaceMap, setNilled, setNodeName, setSystemId, setTypeAnnotation`

    - ### Methods inherited from class net.sf.saxon.tree.linked.ParentNodeImpl

      `addChild, children, compact, getFirstChild, getLastChild, getNthChild, getNumberOfChildren, getRawSequenceNumber, getSequenceNumber, getStringValue, getStringValueCS, hasChildNodes, insertChildren, iterateChildren, removeChild, replaceChildrenAt, setChildren, setRawSequenceNumber`

    - ### Methods inherited from class net.sf.saxon.tree.linked.NodeImpl

      `atomize, compareOrder, effectiveBooleanValue, equals, getDisplayName, getFingerprint, getLocalPart, getNamePool, getNextInDocument, getNextSibling, getParent, getPhysicalRoot, getPrefix, getPreviousInDocument, getPreviousSibling, getRawParent, getSiblingPosition, getSuccessorElement, getTreeInfo, getURI, hasFingerprint, head, insertSiblings, isDeleted, iterateAxis, iterateAxis, newBuilder, replace, saveLocation, setRawParent, setSiblingPosition`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `children, equals, getGenre, getPublicId, hashCode, isSameNodeInfo, isStreamed, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Constructor Detail

    - #### XSLAttributeSet

          public XSLAttributeSet()

  - ### Method Detail

    - #### getActor

          public AttributeSet getActor()

      Get the corresponding Procedure object that results from the compilation of this StylesheetProcedure
      Specified by:
        `getActor` in interface `StylesheetComponent`
      Returns:
        the compiled ComponentCode

    - #### getSymbolicName

          public SymbolicName getSymbolicName()

      Description copied from interface: `StylesheetComponent`
      Get the symbolic name of the component, that is, the combination of the component kind and the qualified name
      Specified by:
        `getSymbolicName` in interface `StylesheetComponent`
      Returns:
        the component's symbolic name

    - #### checkCompatibility

          public void checkCompatibility​(Component component)
                                  throws XPathException

      Check the compatibility of this component with another component that it is overriding
      Specified by:
        `checkCompatibility` in interface `StylesheetComponent`
      Parameters:
        `component` - the overridden component
      Throws:
        `XPathException` - if the components are not compatible (differing signatures)

    - #### isDeclaration

          public boolean isDeclaration()

      Ask whether this node is a declaration, that is, a permitted child of xsl:stylesheet (including xsl:include and xsl:import).
      Overrides:
        `isDeclaration` in class `StyleElement`
      Returns:
        true for this element

    - #### getAttributeSetName

          public StructuredQName getAttributeSetName()

      Get the name of this attribute set
      Returns:
        the name of the attribute set, as a QName

    - #### isDeclaredStreamable

          public boolean isDeclaredStreamable()

      Ask whether the attribute set is declared streamable
      Returns:
        true if the attribute streamable="yes" is present

    - #### prepareAttributes

          public void prepareAttributes()

      Description copied from class: `StyleElement`
      Set the attribute list for the element. This is called to process the attributes (note the distinction from processAttributes in the superclass). Must be supplied in a subclass
      Specified by:
        `prepareAttributes` in class `StyleElement`

    - #### getObjectName

          public StructuredQName getObjectName()

      Get a name identifying the object of the expression, for example a function name, template name, variable name, key name, element name, etc. This is used only where the name is known statically. If there is no name, the value will be null.
      Overrides:
        `getObjectName` in class `StyleElement`
      Returns:
        the name of the object declared in this element, if any

    - #### validate

          public void validate​(ComponentDeclaration decl)
                        throws XPathException

      Description copied from class: `StyleElement`
      Check that the stylesheet element is valid. This is called once for each element, after the entire tree has been built. As well as validation, it can perform first-time initialisation. The default implementation does nothing; it is normally overriden in subclasses.
      Overrides:
        `validate` in class `StyleElement`
      Parameters:
        `decl` - the declaration to be validated
      Throws:
        `XPathException` - if any error is found during validation

    - #### getUseAttributeSetNames

          public StructuredQName[] getUseAttributeSetNames()

    - #### index

          public void index​(ComponentDeclaration decl,
                            PrincipalStylesheetModule top)
                     throws XPathException

      Description copied from class: `StyleElement`
      Method supplied by declaration elements to add themselves to a stylesheet-level index
      Overrides:
        `index` in class `StyleElement`
      Parameters:
        `decl` - the Declaration being indexed. (This corresponds to the StyleElement object except in cases where one module is imported several times with different precedence.)
        `top` - represents the outermost XSLStylesheet or XSLPackage element
      Throws:
        `XPathException` - if any error is encountered

    - #### checkCircularity

          public void checkCircularity​(XSLAttributeSet origin)
                                throws XPathException

      Check for circularity: specifically, check that this attribute set does not contain a direct or indirect reference to the one supplied as a parameter
      Parameters:
        `origin` - the place from which the search started
      Throws:
        `XPathException` - if an error is found

    - #### getContainedInstructions

          public java.util.List<Expression> getContainedInstructions()

      Get the contained xsl:attribute instructions, in compiled form
      Returns:
        the list of contained instructions. This does not include any xsl:use-attribute-set references.

    - #### getSlotManager

          public SlotManager getSlotManager()

      Get details of stack frame
      Specified by:
        `getSlotManager` in interface `StylesheetComponent`
      Returns:
        the associated SlotManager object

    - #### compileDeclaration

          public void compileDeclaration​(Compilation compilation,
                                         ComponentDeclaration decl)
                                  throws XPathException

      Compile the attribute set
      Overrides:
        `compileDeclaration` in class `StyleElement`
      Parameters:
        `compilation` - the current compilation episode
        `decl` - this attribute set declaration
      Throws:
        `XPathException` - if a failure is detected

    - #### optimize

          public void optimize​(ComponentDeclaration declaration)
                        throws XPathException

      Optimize the stylesheet construct
      Specified by:
        `optimize` in interface `StylesheetComponent`
      Parameters:
        `declaration` - this attribute set declaration
      Throws:
        `XPathException`

    - #### generateByteCode

          public void generateByteCode​(Optimizer opt)

      Generate byte code if appropriate
      Specified by:
        `generateByteCode` in interface `StylesheetComponent`
      Parameters:
        `opt` - the optimizer